//
//  THIImageCell.m
//
//  Created by Scott Stevenson on 11/13/05.
//  Copyright 2005 Tree House Ideas. All rights reserved.
//

#import "THIImageCell.h"


@implementation THIImageCell

- (void) drawWithFrame:(NSRect)frame inView:(NSView *)controlView
{
        NSImage * myImage = [self image];
        if ( myImage == nil )
        {
                [super drawWithFrame:frame inView:controlView];
                return;
        }
        
        // make a copy of the cell size for the image rect
        
        NSSize size = frame.size; 
        
        // keep proportional
        
        if ( size.width > size.height ) {
                size.width = size.height;                        
        } else if ( size.height > size.width ) {
                size.height = size.width;
        }
        
        // figure out where the image's vertical coord should be
        
        float startY = frame.origin.y + size.height + ((frame.size.height - size.height) / 2);
        float startX = frame.origin.x - ((size.width - frame.size.width) / 2);
                                        
        // make resizing look pretty
        
        NSRect rect = NSMakeRect ( 0, 0, size.width, size.height );
        NSImage * temp = [[NSImage alloc] initWithSize:rect.size];
        [temp lockFocus];
        [[NSGraphicsContext currentContext] setImageInterpolation: NSImageInterpolationHigh];
        [temp unlockFocus];
        
        // resize image
        
        NSPoint point = NSMakePoint( startX, startY );
        [myImage setSize: size];
        [myImage setScalesWhenResized: YES];
        
        // draw image in cell
        
        [myImage compositeToPoint:point operation:NSCompositeSourceOver];
        [temp release];
}

@end
